/* This file is part of the KDE project
   Copyright (C) 1998, 1999, 2000 Torben Weis <weis@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#include "kscript_qt.h"
#include "kscript_qstructs.h"
#include "kscript_value.h"
#include "kscript_util.h"
#include "kscript.h"
#include "kscript_object.h"

KSModule::Ptr ksCreateModule_Qt( KSInterpreter* interp )
{
  KSModule::Ptr module = new KSModule( interp, "qt" );

  // Add all Qt classes to the module
  module->addObject( "QRect", new KSValue( new KSQt::Rect( module, "QRect" ) ) );
  module->addObject( "QPoint", new KSValue( new KSQt::Point( module, "QPoint" ) ) );
  module->addObject( "QSize", new KSValue( new KSQt::Size( module, "QSize" ) ) );

  return module;
}

